/*
 * swmod_api.h: Abstracted API for swmod
 *
 * Copyright (C) 2021 iopsys Software Solutions AB. All rights reserved.
 *
 * Author: Vivek Dutta <vivek.dutta@iopsys.eu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#ifndef __SWMOD_API_H
#define __SWMOD_API_H
#include <stdbool.h>
#include "swmod.h"
#include "tools.h"

int swmod_run_cmd(ExecEnv_t *ee, const char *cmd, char *output, int out_len);
int swmod_install_package(ExecEnv_t *env, PkgInfo *pkg, char *output, int outlen);
int swmod_update_package(ExecEnv_t *env, PkgInfo *pkg, char *output, int outlen);
int swmod_remove_package(ExecEnv_t *env, const PkgInfo *pkg, char *output, int outlen);
void swmod_change_ee_state(ExecEnv_t *env, char *state, struct blob_buf *bb);
void populate_execution_unit(ExecEnv_t *env);
void swmod_get_pid_detail(ExecEnv_t *env, int pid, char *cmdline, int cmd_len, int *vsize);
void swmod_set_service_state(ExecEnv_t *env, char *name, bool state, struct blob_buf *bb);
void swmod_get_env_info(ExecEnv_t *env);
void swmod_set_ee_alias(ExecEnv_t *env, const char *alias, struct blob_buf *bb);
void swmod_set_du_alias(ExecEnv_t *env, const char *uuid, const char *alias, struct blob_buf *bb);
void swmod_set_eu_alias(ExecEnv_t *env, const char *eu_name, const char *alias, struct blob_buf *bb);
void swmod_set_eu_autostart(ExecEnv_t *env, const char *eu_name, bool enable, struct blob_buf *bb);

#endif //__SWMOD_API_H
